import Base from "comptechsoft-vue-foundation/src/Base";
import Collection from "./../Collection/Collection"
import Vueapp from "comptechsoft-vue-foundation/src/Classes/App/Vueapp";

class App extends Base {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)

        this.AddProperty('classes', new Collection('app-libs'))
        this.AddProperty('vueapp', new Vueapp('vue-app'))

        this.SetVueComponents(require.context('./../../Vue/Components/Forms/~Components', true, /\.vue$/i))
        this.SetVueStores(require.context('./../../Vue/Stores', true, /\.store.js$/i))
        this.SetVueMixins(require.context('./../../Vue/Mixins', true, /\.mixin.js$/i))

    }

    CreateVueApp() {
        return this.vueapp.Create()
    }

    SetVueComponents(context) {
        this.vueapp.SetComponents(context)
        return this
    }

    SetVueStores(context) {
        this.vueapp.SetStores(context)
        return this
    }

    SetVueMixins(context) {
        this.vueapp.SetMixins(context)
        return this
    }

    SetVueData(data) {
        this.vueapp.SetData(data)
        return this
    }

    SetFunctions(CT, context) {
        context.keys().map(key => {
            let name = key.split('/').pop().split('.')[0]
            CT[name] = context(key)
        })
    }

    SetLocales(CT, context) {
        CT.locale = document.head.querySelector('meta[name="locale"]').content
        CT.locales = context('./' + CT.locale  + '.js')
    }

    // SetClassLib(context) {
    //     context.keys().map(key => {
    //         let name = key.split('/').pop().split('.')[0]
    //         // console.log(key + ' : ' + name)
    //         this.classes.Put(name, context(key).default)
    //     })
    //     return this
    // }

    // CreateObject(className, name, parent = null, onInit = null) {
    //     if( ! this.classes.Has(className) )
    //     {
    //         throw new Error('Class definition [' + className + '] not exists.')
    //     }
    //     let classDef = this.classes.Get(className)
    //     return new classDef(name, parent, onInit)
    // }

}

export default App