import Base from "comptechsoft-vue-foundation/src/Base";
import Axios from "comptechsoft-vue-foundation/src/Classes/Axios/Axios";

class Config extends Base {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)

        this.AddProperty('user')
        this.AddProperty('roles')
        this.AddProperty('environment')
        this.AddProperty('short_name')
        this.AddProperty('locale')
        this.AddProperty('url')
        this.AddProperty('timezone')
        this.AddProperty('debug')
        this.AddProperty('version')
        this.AddProperty('currency_symbol')
        this.AddProperty('digit_group_separator')
        this.AddProperty('decimal_character')

        this.AddProperty('ready')
    }

    set(data) {
        this.Set('user', data.user)
        this.Set('roles', data.roles)        
        _.each(data.config, (value, key) => this.Set(key, value))


        alert('Config')
        console.log(axios)
        this.Set('ready', true)
    }

    SetConfig() {
        let axios = new Axios('axios', this)
            .Endpoint('app/config/get')
            .Success(data => this.set(data))
            
        return axios.Post()
    }

    GetConfig() {
        return {
            user: this.user,
            roles: this.roles,
            environment: this.environment,
            name: this.name,
            short_name: this.short_name,
            locale: this.locale,
            url: this.url,
            timezone: this.timezone,
            debug: this.debug,
            version: this.version,
            currency_symbol: this.currency_symbol,
            digit_group_separator: this.digit_group_separator,
            decimal_character: this.decimal_character,
            ready: this.ready,
        }
    }

    
}

export default Config