import Base from "comptechsoft-vue-foundation/src/Base";

class Vueapp extends Base {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)

        this.AddProperty('modules', {})
        this.AddProperty('data')
    }

    Create() {
        return new Vue({
            el: '#v-app',
            store: new Vuex.Store({modules: this.modules}),
            data: _.extend({}, this.data),
            mounted() {
                this.$store.dispatch('Config/Set')
            },
            name: 'RootVueApp',
        })
    }

    SetData(data) {
        return this.Set('data', data)
    }

    SetComponents(context) {
        context.keys().map(key => {
            let name = key.split('/').pop().split('.')[0]
            console.log('Component:>>>' + key + ' = = >>' + name)
            Vue.component(name, context(key).default)
        })
        return this
    }

    SetStores(context) {
        context.keys().map(key => {
            let name = key.split('/').pop().split('.')[0]
            this.modules[name] = context(key).default
        })
    }

    SetMixins(context) {
        context.keys().map(key => {
            Vue.mixin(context(key))
        })
    }

}

export default Vueapp