import Axios from './Axios'

class Form extends Axios {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)

        this.AddProperty('errors')
        this.AddProperty('exception')
        this.AddProperty('result')

        this.AddProperty('onFail', data => {
            this.Set('errors', data.errors)
            this.Set('exception', data.exception)            
        })

        this.AddProperty('onGo', data => {
            alert('on Goooo goooo');
        })

        this.Set('onSuccess', data => {
            this.Set('success', data.success)
            this.Set('result', data.result)
            if( data.success )
            {
                if(_.isFunction(this.onGo) )
                { 
                    this.onGo(data)
                }
            }
            else
            {
                if(_.isFunction(this.onFail) )
                { 
                    this.onFail(data)
                }
            }            
        }) 
    }

    SetOnGo(onGo) {
        this.Set('onGo', onGo)
        return this
    }

    ResetErrors() {
        this.Set('errors', null)
    }

    ResetResult() {
        this.Set('result', null)
    }

    ResetException() {
        this.Set('exception', null)
    }

    ResetAll() {
        this.ResetErrors()
        this.ResetResult()
        this.ResetException()
    }

    Errors() {
        return this.errors
    }

    Messages() {
        if( ! this.errors )
        {
            return null
        }
        let r = [];
        _.each(this.errors, (error, key) => {
            _.each(error, message => r.push(message))
        })
        return r
    }

    Exception() {
        return this.exception
    }

    Result() {
        return this.result
    }
    
}

export default Form