import Component from "comptechsoft-vue-foundation/src/Vue/Components/Component";
import Collection from "comptechsoft-vue-foundation/src/Classes/Collection/Collection";

class Condition extends Component {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)

        this.AddProperty('type')
        this.AddProperty('field')
        this.AddProperty('operators', new Collection('operators'))
        this.AddProperty('value')
        this.AddProperty('current_operator')
    }

    MakeStringOperators() {
        this.operators.Put('start', {
            caption: 'Incepe cu ...',
            where: "" + this.field + " LIKE '[value]%'"
        })
        this.operators.Put('end', {
            caption: 'Se termina cu ...',
            where: "" + this.field + " LIKE '%[value]'"
        })
        this.operators.Put('in', {
            caption: 'Contine ...',
            where: "" + this.field + " LIKE '%[value]%'"
        })
        
        this.Set('current_operator', 'start')
    }

    MakeIntegerOperators() {
        this.operators.Put('equal', {
            caption: 'Egal cu',
            where: "" + this.field + " = [value]"
        })
        this.operators.Put('less', {
            caption: 'Mai mic decat ...',
            where: "" + this.field + "  < [value]"
        })
        this.operators.Put('greater', {
            caption: 'Mai mare decat ...',
            where: "" + this.field + " > [value]"
        })
        
        this.Set('current_operator', 'equal')
    }

    SetField(field) {
        return this.Set('field', field)
    }

    SetType(type) {
        switch(type)
        {
            case 'string': 
            {
                this.MakeStringOperators()
                break
            }
            case 'integer': 
            {
                this.MakeIntegerOperators()
                break
            }
        }
        return this.Set('type', type)
    }

    GetOperatorItem() {
        return this.operators.Get(this.current_operator)
    }
}

export default Condition