import Collection from "comptechsoft-vue-foundation/src/Classes/Collection/Collection";
import Condition from "comptechsoft-vue-foundation/src/Classes/Fetcher/Condition";

class Conditions extends Collection {

    constructor(name, parent = null, onInit = null) {
        super(name, parent, onInit)
    }

    SetCondition(condition) {

        if(! _.isObject(condition) || ! (condition instanceof Condition))
        {
            throw new Error('Condition must be instance of Condition Object.')
        }
        return this.Put(condition.name, condition)
    }

    GetConditions() {
        let r = {}
        _.each(this.All(), condition => {
            r[condition.name] = {
                operators: condition.operators.All(),
                current_operator: condition.current_operator,
                data: {
                    value: condition.value,
                }
            }
        })
        return r
    }

    HasConditions() {
        let r = false
        _.each(this.All(), condition => {
            if(condition.visible)
            {
                r = true
            }
        })
        return r
    }

    AllVisibles() {
        let c = new Collection('visibles')
        _.each(this.All(), (item, key) => {
            if( item.visible )
            {
                c.Put(key, item)
            }
        })
        return c.All()
    }

}

export default Conditions