module.exports = (portlet = null, datatable, fetcher = null) => {

    form = vue => {

        let dtp = null

        /** Portlet object, caption */
        if(portlet.hasOwnProperty('CreatePortlet'))
        {
            dtp = portlet.CreatePortlet(vue)
        }
        else
        {
            const DatatablePortlet = require('comptechsoft-vue-foundation/src/Vue/Components/Metronic/Portlets/Datatable/DatatablePortlet').default

            dtp = new DatatablePortlet(portlet.key)
                .SetCaption(portlet.caption)
                .SetIcon(portlet.icon)

            /** Portlet tools */
            _.each(portlet.tools, node => dtp.tools.AddNode(node))

            if(fetcher)
            {
                if(_.isFunction(fetcher))
                {
                }
                else
                {
                    /** Fetcher endpoint, per_page, search_by */
                    dtp.fetcher
                        .Endpoint(fetcher.endpoint)
                        .SetPerPage(fetcher.per_page)
                        .SetSearchBy(fetcher.search_by)
                    
                    /** Fetcher default order */
                    if(fetcher.default_order)
                    {
                        dtp.fetcher.Set('current_order', fetcher.default_order)
                    }

                    /** Fetcher order by  */
                    _.each(fetcher.order_by, item => dtp.fetcher.SetOrderable(item.key, item.type, item.fields))

                    /** Fetcher conditions */
                    _.each(fetcher.conditions, condition => {
                        if(_.isFunction(condition))
                        {
                            dtp.fetcher.SetCondition(condition())
                        }
                        else
                        {
                            dtp.fetcher.SetCondition(condition)
                        }
                    })    
                }
            }
        

            /** datatable columns */
            _.each(datatable.columns, column => dtp.datatable.AddColumn(column))

            /** datatable actions */
            _.each(datatable.actions, action => dtp.datatable.AddAction(action))

            /** datatable row detail */
            dtp.datatable.Set('details_component', datatable.details_component)

            if(datatable.hasOwnProperty('messages'))
            {
                dtp.datatable.Set('messages', datatable.messages)
            }
        }


        return dtp
    }

    return {
        key: portlet.key,
        form,
    }
}