import Component from "./../Component"
import Header from "comptechsoft-vue-foundation/src/Vue/Components/Datatable/Header"
import Source from "comptechsoft-vue-foundation/src/Vue/Components/Datatable/Source"

class Column extends Component {
    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('width')
        this.AddProperty('header', new Header('header'))
        this.AddProperty('source', new Source('source'))

    }

    SetWidth(width) {
        this.Set('width', width)
        this.SetWidthStyle()
        return this
    }

    SetWidthStyle() {
        this.header.SetWidthStyle(this.width)
        this.source.SetWidthStyle(this.width)
        return this
    }

    SetCaption(caption) {
        this.header.SetCaption(caption)
        return this
    }

    AlignRight() {
        this.source.AddStyle('text-align', 'right')
        return this
    }

    AlignCenter() {
        this.source.AddStyle('text-align', 'center')
        return this
    }

    SetRenderer(renderer) {
        this.source.SetRenderer(renderer)
        return this
    }
} 

export default Column