import Component from "comptechsoft-vue-foundation/src/Vue/Components/Component"
import Labelbox from "comptechsoft-vue-foundation/src/Vue/Components/Forms/Controls/HTML/Labelbox"
import Combobox from "comptechsoft-vue-foundation/src/Vue/Components/Forms/Controls/HTML/Combobox"
import Helpbox from "comptechsoft-vue-foundation/src/Vue/Components/Forms/Controls/HTML/Helpbox"

class FormGroupCombobox extends Component {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddClass('form-group')

        this.AddProperty('label', new Labelbox(name + '-label'))
        this.AddProperty('combobox', new Combobox(name + '-combobox'))
        this.AddProperty('helpbox', new Helpbox(name + '-helpbox'))

        this.combobox.AddClass('form-control')

    }

    Custom() {
        this.combobox.RemoveClass('form-control').AddClass('custom-select')
        return this
    }

    SetCaption(caption) {
        this.label.layout.Set('caption', caption)
        return this
    }

    SetId(id) {
        this.label.Set('for', id)
        this.combobox.Set('id', id) 
        return this
    }

    AddOption(option) {
        this.combobox.AddOption(option)
        return this
    }

    Empty() {
        this.combobox.Empty()
        return this
    }

    SetNullOption(option) {
        this.combobox.SetNullOption(option)
        return this
    }

    AddOptionById(id, text) {
        this.combobox.AddOptionById(id, text)
        return this
    }

    SetHelp(help) {
        this.helpbox.layout.Set('caption', help)
        return this
    }

    /**
     * Sizes
     */
    SetSize(size) {
        if(this.combobox.layout.htmlClass.Get('form-control') === true)
        {

            this.combobox.layout.AddClass('form-control-' + size)
        }
        else
        {
            if(this.combobox.layout.htmlClass.Has('custom-select') === true)
            {
                this.combobox.layout.AddClass('custom-select-' + size)
            }
        }
        return this
    }

    Large() {
        return this.SetSize('lg')
    }

    Small() {
        return this.SetSize('sm')
    }

    Readonly(readonly = true) {
        this.combobox.Readonly(readonly)
        this.Disabled()
        return this
    }

    Disabled() {
        this.combobox.Disabled()
        return this
    }

    Enabled() {
        this.combobox.Enabled()
        return this
    }

    SetValue(value) {
        this.combobox.Value(value) 
        return this
    }

    GetValue() {
        return this.combobox.value
    }

}

export default FormGroupCombobox