import FormGroupTextbox from "comptechsoft-vue-foundation/src/Vue/Components/Forms/Controls/BsFormGroup/Textbox"

/**
 * https://bootstrap-datepicker.readthedocs.io/en/latest/index.html
 */

class FormGroupDatepicker extends FormGroupTextbox {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)
        this.AddProperty('instance', null)
        this.AddProperty('format', {
            datepicker: 'dd.mm.yyyy',
            moment: 'DD.MM.YYYY',
            mysql: 'YYYY-MM-DD HH:mm:ss',
        })

    }

    SetValue(value) {
        if(value)
        {
            value = moment(value, this.format.mysql).format(this.format.moment)
            this.textbox.Value(value) 
        }
        return this 
    }

    GetValue() {
        if(! this.textbox.value ) 
        {
            return null
        }
        return moment(this.textbox.value, this.format.moment).format(this.format.mysql)
    }

    InitDatePicker() {
        if(! this.instance)
        {
            let self = this
            let i = setInterval( () => {
                let jq = $('#' + this.textbox.id)
                if( jq.length > 0) 
                {
                    clearInterval(i)
                    this.Set('instance', 
                        jq.datepicker({
                            format: this.format.datepicker,
                            todayBtn: 'linked',
                            clearBtn: true
                        })
                        .on('changeDate', function(e) {
                            console.log('changeDateTriggered', moment(e.date))
                            self.textbox.value =  moment(e.date).format(self.format.moment)
                        })
                    )
                }
            }, 10)
        }
    }

}

export default FormGroupDatepicker