import FormGroupTextbox from "comptechsoft-vue-foundation/src/Vue/Components/Forms/Controls/BsFormGroup/Textbox"

/**
 * https://www.malot.fr/bootstrap-datetimepicker/
 */

class FormGroupDatetimepicker extends FormGroupTextbox {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('instance', null)

        this.AddProperty('format', {
            datepicker: 'dd.mm.yyyy hh:ii',
            moment: 'DD.MM.YYYY HH:mm',
            mysql: 'YYYY-MM-DD HH:mm:ss',
        })

        this.AddProperty('options', {
            format: this.format.datepicker,
            weekStart: 1,
            autoclose: true,
            todayBtn: 'linked',
            todayHighlight: true,
            language: 'ro',
            minuteStep: 1,
        })

    }

    SetValue(value) {
        if(value)
        {
            value = moment(value, this.format.mysql).format(this.format.moment)
            this.textbox.Value(value) 
        }
        return this 
    }

    GetValue() {
        if(! this.textbox.value ) 
        {
            return null
        }
        return moment(this.textbox.value, this.format.moment).format(this.format.mysql)
    }

    InitDateTimePicker() {
        if(! this.instance)
        {
            let self = this
            let i = setInterval( () => {
                let jq = $('#' + this.textbox.id)
                if( jq.length > 0) 
                {
                    clearInterval(i)
                    this.Set('instance', 
                        jq.datetimepicker(this.options)
                        .on('changeDate', function(e) {
                            console.log('changeDateTriggered', moment(e.date))
                            self.textbox.value =  moment(e.date).format(self.format.moment)
                            console.log('Value: ' + self.textbox.value)
                        })
                    )
                }
            }, 10)
        }
    }

}

export default FormGroupDatetimepicker