import Control from "comptechsoft-vue-foundation/src/Vue/Components/Forms/Controls/Control";

class Combobox extends Control {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('options', [])
        this.AddProperty('multiple', null)
        this.AddProperty('null_option', null)

    }

    AddOption(option) {
        if(! option.hasOwnProperty('id') )
        {
            throw new Error('The option do not has the [id] property')
        }
        if(! option.hasOwnProperty('text') )
        {
            throw new Error('The option do not has the [text] property')
        }
        let exists = _.find(this.options, record => option.id == record.id)
        if(exists == undefined)
        {
            this.options.push(option)
        }
        return this
    }

    AddOptionById(id, text) {
        return this.AddOption({id, text})
    }

    Empty() {
        return this.Set('options', [])
    }

    SetNullOption(option) {
        return this.Set('null_option', option)
    }

}

export default Combobox