import Component from "comptechsoft-vue-foundation/src/Vue/Components/Component" 
import Axios from "comptechsoft-vue-foundation/src/Classes/Axios/Form"

class Form extends Component {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('controls', {})
        this.AddProperty('axios', new Axios('axios'))
    }

    SetEndpoint(endpoint) {
        this.axios.Endpoint(endpoint)
        return this
    }

    SetOnGo(onGo) {
        this.axios.SetOnGo(onGo)
        return this
    }

    ResetErrors() {
        this.axios.ResetErrors()
        return this
    }

    ResetResult() {
        this.axios.ResetResult()
        return this
    }

    AddControl(control) {
        Vue.set(this.controls, control.name, control)
        return this
    }

    GetValues() {
        let r = {}
        _.each(this.controls, (control, key)  => {
            r[key] = control.GetValue()
        })
        return r
    }

    Processing() {
        return this.axios.GetPropertyValue('processing')
    }

    Errors() {
        return this.axios.Errors()
    }

    Messages() {
        return this.axios.Messages()
    }

    Exception() {
        return this.axios.Exception()
    }

    Result() {
        return this.axios.Result()
    }

    Submit(values = null) {
        if( ! values )
        {
            values = this.GetValues()
        }
        this
            .ResetErrors()
            .ResetResult()
        return this.axios.SetData(values).Post()
    }
    
}

export default Form