import Portlet from 'comptechsoft-vue-foundation/src/Vue/Components/Metronic/Portlets/Portlet'
import Fetcher from 'comptechsoft-vue-foundation/src/Classes/Fetcher/Fetcher'
import Datatable from 'comptechsoft-vue-foundation/src/Vue/Components/Datatable/Datatable'

class DatatablePortlet extends Portlet {

    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('fetcher', new Fetcher('fecher'))
        this.AddProperty('datatable', new Datatable('datatable'))
        
        this.AddProperty('filter_form_is_visible', false)
    }

    Populate() {
        this.fetcher.Post()
    }

    Loading() {
        return this.fetcher.processing
    }

    RecordCount() {
        return this.fetcher.RecordCount()
    }

    CurrentPage() {
        return this.fetcher.CurrentPage()
    }

    PerPage() {
        return this.fetcher.PerPage()
    }

    From() {
        return this.fetcher.From()
    }

    To() {
        return this.fetcher.To()
    }

    Total() {
        return this.fetcher.Total()
    }

    Records() {
        return this.fetcher.Records()
    }

    /**
     * Datatable
     */
    Headers() {
        return this.datatable.Headers()
    }

    ColumnSources() {
        return this.datatable.ColumnSources()
    }

    Actions() {
        return this.datatable.Actions()
    }

    /**
     * Filtering
     */
    FilterFormIsVisible() {
        return this.filter_form_is_visible
    }

    ShowFilterForm() {
        return this.Set('filter_form_is_visible', true)
    }

    HideFilterForm() {
        return this.Set('filter_form_is_visible', false)
    }

}

export default DatatablePortlet