import Component from "./../Component"
import Collection from "./../../../Classes/Collection/Collection"

class Tree extends Component {
    
    constructor(name, parent = null, onInit = null) {

        super(name, parent, onInit)

        this.AddProperty('nodes', new Collection('nodes', this))
        this.AddProperty('badge')
    }

    AddNode(node) {
        if( ! _.isObject(node) || ! (node instanceof Tree) )
        {
            throw new Error(this.name + '. Node must be a Tree instance.')
        }
        this.nodes.Push(node)
        return this
    }

    Count(vue = null) {
        return this.Children(vue).Count()
    }

    Children(vue = null) {
        let c = new Collection('visible-items')
        _.each(this.nodes.All(), (node, key) => {
            if( _.isBoolean(node.visible) )
            {
                if( node.visible )
                {
                    c.Put(key, node)
                }
            }
            else
            {
                if( _.isFunction(node.visible) )
                {
                    if(node.visible(vue))
                    {
                        c.Put(key, node) 
                    }        
                }
            }
        })
        return c
    }
}

export default Tree