import Axios from "./../Axios";

class AxiosCrud extends Axios {

    constructor() {
        super()

        this.endpoints = null

        this.onSuccess = () => {
            console.log('==== [AxiosCrud::onSuccess()] ====')
            if(this.response.success)
            {
                this.onSuccessResponse()
            }
            else
            {
                this.onFailedResponse()
            }
        }

        this.onSuccessResponse = () => {
            console.log('SUCCESS')
            
        }

        this.onFailedResponse = () => {
            console.log('FAILED')
        }
    }

    SetEndpoints(endpoints) {
        this.endpoints = {}
        _.each(endpoints, (value, key) => this.endpoints[key] = value)
        return this
    }

    SetOnSuccessResponse(value) {
        this.onSuccessResponse = value
        return this
    }

    SetOnFailedResponse(value) {
        this.onFailedResponse = value
        return this
    }

    get successResponse() {
        return this.response ? this.response.success : null
    }

    get result() {
        return this.response ? this.response.result : null
    }

    get errors() {
        return this.response ? this.response.errors : null
    }

    get exception() {
        return this.response ? this.response.exception : null
    }

    get message() {
        return this.result ? this.result.message : null
    }

    Post() {
        this.ResetResponse()
        super.Post()
    }
}

export default AxiosCrud