import Base from "../../Base";
import Collection from "../../Collection/Collection";
import AxiosFetcherConditionsColumn from "./AxiosFetcherConditionsColumn"

class AxiosFetcherConditions extends Base {

    constructor() {

        super()

        this.columns = new Collection()
    }

    AddCondition(name, field, type) {
        let column = new AxiosFetcherConditionsColumn(field, type)
        this.columns.Put(name, column)
        return this
    }

    Condition(name, current_operator, data) {
        let column = this.columns.Get(name)
        column.SetData(data)
        column.SetCurrentOperator(current_operator)
        return this
    }

    get conditions() {
        let r = {}
        _.each(this.columns.All(), (column, key) => {
            r[key] = {
                operators: column.columnOperators,
                current_operator: column.currentOperator,
                data: column.data,
            }
        })
        return r
    }

    ResetConditions() {
        _.each(this.columns.All(), (column, key) => {
            column.ResetData()
        })
        return this
    }
}

export default AxiosFetcherConditions