import Base from "../../Base";
import AxiosFetcherConditionsColumnOperators from "./AxiosFetcherConditionsColumnOperators";

class AxiosFetcherConditionsColumn extends Base {

    constructor(field, type) {

        super()

        if(_.isString(type))
        {
            switch(type)
            {
                case 'string':
                case 'integer':
                    this.data = {value: null}
                    break;
                case 'numeric': {
                    this.data = {value: null, value_to: null}
                    break;
                }
                case 'date':
                    this.data = {
                        dateStart: null,
                        dateEnd:null
                    }
                    break;
                default:
                    this.data = {}
            }
            this.operators = new AxiosFetcherConditionsColumnOperators(field, type)
        }
        else 
        {
            if(_.isObject(type))
            {
                this.data = type.data
                this.operators = type.operators
            }
        }
    }

    SetData(data) {
        _.each(data, (value, key) => this.data[key] = value)
        return this
    }

    SetCurrentOperator(current_operator) {
        this.operators.current_operator = current_operator
        return this
    }

    get columnOperators() {
        return this.operators.operators.All()
    }

    get currentOperator() {
        return this.operators.current_operator
    }

    ResetData() {
        _.each(this.data, (value, field) => {
            Vue.set(this.data, field, null)
        })
        return this
    }
}

export default AxiosFetcherConditionsColumn