import Base from "../../Base";
import Collection from "../../Collection/Collection";
import AxiosFetcherConditionsColumnOperator from "./AxiosFetcherConditionsColumnOperator";

class AxiosFetcherConditionsColumnOperators extends Base {

    constructor(field, type = null) {
        super()

        this.field = field
        this.type = type
        this.operators = new Collection()
        this.current_operator = null

        if(type)
        {
            this['Add' + _.capitalize(type) + 'Operators']()
        }
    }

    AddStringOperators() {
        this.Put('equal', new AxiosFetcherConditionsColumnOperator(this.field + " = '[value]'"))
        this.Put('start', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '[value]%'"))
        this.Put('end', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '%[value]'"))
        this.Put('in', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '%[value]%'"))
    }

    AddDateOperators() {
        this.operators.Put('between', new AxiosFetcherConditionsColumnOperator(this.field + " BETWEEN '[dateStart]' AND '[dateEnd]'"))
        // this.operators.Put('start', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '[value]%'"))
        // this.operators.Put('end', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '%[value]'"))
        // this.operators.Put('in', new AxiosFetcherConditionsColumnOperator(this.field + " LIKE '%[value]%'"))
    }

    AddIntegerOperators() {
        this.Put('equal', new AxiosFetcherConditionsColumnOperator(this.field + " = [value]"))
        this.Put('less', new AxiosFetcherConditionsColumnOperator(this.field + "  < [value]"))
        this.Put('greater', new AxiosFetcherConditionsColumnOperator(this.field + " > [value]"))
    }

    AddNumericOperators() {
        this.Put('equal', new AxiosFetcherConditionsColumnOperator(this.field + " = [value]"))
        this.Put('less', new AxiosFetcherConditionsColumnOperator(this.field + "  < [value]"))
        this.Put('greater', new AxiosFetcherConditionsColumnOperator(this.field + " > [value]"))
        this.Put('between', new AxiosFetcherConditionsColumnOperator(this.field + " BETWEEN [value] AND [value_to]"))
    }

    Put(key, value) {
        this.operators.Put(key, value)
        return this
    }

    SetCurrentOperator(value) {
        this.current_operator = value
        return this
    }
}

export default AxiosFetcherConditionsColumnOperators