import Base from "../../Base";
import Collection from "../../Collection/Collection";
import AxiosFetcherOrderColumn from "./AxiosFetcherOrderColumn"

class AxiosFetcherOrder extends Base {

    constructor() {
        super()

        this.columns = new Collection()
        
        this.current_order = null
    }
    
    get currentOrder() {
        if( ! this.current_order )
        {
            return null
        }
        let r = this.columns.Get(this.current_order)
        r.direction = r.direction || 'asc'
        return r
    }

    AddOrderColumn(key, fields) {
        let column = new AxiosFetcherOrderColumn()
        column.fields = fields
        this.columns.Put(key, column)
        return this
    }

    Order(key, direction) {
        this.current_order = key
        this.columns.items[key].direction = direction
        return this
    }


    
}

export default AxiosFetcherOrder