import Base from "../Base";

/**
 * Varianta 1. Cu Promise
 * axios.MakeRequest('Google').then(r => axios.ProcessRequest(r)).then(r => console.log(r)) catch(e => console.log(e))
 */
class Axios extends Base {

    constructor() {
        super();
    }

    MakeRequest(location) {

        let executor = (resolve, reject) => {
            console.log('Axios::MakeRequest(' + location + ')')
            if( location === 'Google' )
            {
                resolve('Connected to ' + location + ' with success.')
            }
            else
            {
                reject('Connection to ' + location + ' refused.')
            }
        }
        
        return new Promise(executor)
    }

    ProcessRequest(response) {

        let executor = (resolve, reject) => {
            console.log('Axios::ProcessRequest()')
            resolve('Response >> ' + response)
        }

        return new Promise(executor)
    }

    Request(location) {
        this.MakeRequest(location)
            .then(r => this.ProcessRequest(r))
            .then(r => console.log(r)) 
            .catch(e => console.log(e))
    }

    async Work(location) {
        try
        {
            const r1 = await this.MakeRequest(location)
            console.log('Connection OK')
            const r2 = await this.ProcessRequest(r1)
            console.log('Process >> ' + r2)
        }
        catch(e)
        {
            console.log(e)
        }
        
    }

}

export default Axios