import Base from "../Base";
import Header from "./Header";
import Source from "./Source"

class Column extends Base {

    constructor(name) {
        super()

        this.name = name

        this.width = null

        this.header = new Header()

        this.source = new Source()
    }

    SetWidth(value) {
        this.width = value
        return this
    }

    SetCaption(value) {
        this.header.caption = value
        return this
    }

    SetType(value) {
        this.source.type = value
        return this
    }

    SetRenderer(value) {
        this.source.renderer = value
        return this
    }

    SetCellTitle(value) {
        this.source.title = value
        return this
    }

    SetOrderable(value) {
        this.header.orderable = value
        return this
    }

    SetOnClick(value) {
        this.source.SetOnClick(value)
        return this
    }

    AddHeaderStyle(value) {
        _.each(value, (v, k) => {
            this.header.htmlStyle[k] = v
        })
        return this
    }

    AddSourceStyle(value) {
        _.each(value, (v, k) => {
            this.source.htmlStyle[k] = v
        })
        return this
    }

    SetFilterable(value) {
        this.header.SetFilterable(value)
        return this
    }

    get headerStyle() {
        let r = {
            width: this.width + '% !important',
        }
        _.each(this.header.htmlStyle, (v, k) => {
            r[k] = v
        })
        return r
    }

    get dataStyle() {
        let r = {
            width: this.width + '% !important',
        }
        _.each(this.source.htmlStyle, (v, k) => {
            r[k] = v
        })
        return r
    }

    get dataTitle() {
        return this.source.title
    }

    get sourceType() {
        return this.source.type
    }

    get sourceRenderer() {
        return this.source.renderer
    }


}

export default Column