import Base from "../Base";
import Collection from "../Collection/Collection"
import DetailsRow from "comptechsoft-vue-foundation/src/~compvuetech/Classes/Datatable/DetailsRow";

class Datatable extends Base {

    constructor(name) {
        super()

        this.name = name

        this.columns = new Collection()

        this.details_row = new DetailsRow()
    }

    AddColumn(column) {
        this.columns.Put(column.name, column)
        return this
    }

    AddDetailsRow(value) {
        this.details_row.component = value
        return this
    }

    get columnCount() {
        return this.columns.Count()
    }

    get columnsTotalWidth() {
        let width = 0, columns = this.columns.All()
        _.each(columns, col => {
            width += col.width
        })
        return width
    }

    get detailsComponent() {
        return this.details_row.component
    }

    get detailedRecords() {
        return this.details_row.detailed
    }

    AddToDetailed(id) {
        this.details_row.AddToDetailed(id)
    }

    RemoveFromDetailed(id) {
        this.details_row.RemoveFromDetailed(id)
    }

    RowIsDetailed(id) {
        return this.details_row.Exists(id)
    }
}

export default Datatable