import DeleteRecord from 'comptechsoft-vue-foundation/src/~compvuetech/Classes/DeleteRecord/DeleteRecord'

class DeleteAll extends DeleteRecord {

    constructor(endpoint) {
        super()

        this.title = 'Confirmare ștergere.'
        this.content = (vue) => {
            return 'Sunteti sigur că doriți ștergerea tuturor înregistrărilor?'
        } 
      
        this.SetEndpoint(endpoint)
    }

    ConfirmedDelete(vue, fetcher = null) {
        let axios = this
        fetcher = fetcher || vue.fetcher
        $.confirm({
            title: this.title,
            closeIcon: true,
            content: '<br/>' + this.content(vue),
            type: 'red',
            typeAnimated: true,
            buttons: {
                confirm: {
                    text: 'Șterge',
                    btnClass: 'btn-danger btn-sm btn-font-sm',
                    keys: ['enter', 'shift'],
                    action: function(){
                        vue.$emit('start-delete-all');
                        axios.SetData(null).OnSuccess( () => {
                            vue.$emit('end-delete-all', axios.response)
                            fetcher.Refresh()
                        }).Post()
                    }
                },
                cancel: {
                    text: 'Renunță',
                    btnClass: 'btn-secondary btn-sm',
                    action: function () {},
                },
                
            }
        });
    }

}

export default DeleteAll