import Axios from './../Axios/Axios'

class DeleteRecord extends Axios {

    constructor(endpoint) {
        super()

        this.title = 'Confirmare ștergere.'
        this.content = (vue, record) => {
            return 'Sunteti sigur că doriți ștergerea ' + record.id + ' (' + vue.$options.name + ')<br/><br/>Endpoint: ' + this.endpoint
        } 
      
        this.SetEndpoint(endpoint)
    }

    SetTitle(value) {
        this.title = value
        return this
    }

    SetContent(value) {
        this.content = value
        return this
    }

    ConfirmedDelete(vue, record, fetcher = null) {
        let axios = this
        fetcher = fetcher || vue.fetcher
        $.confirm({
            title: this.title,
            closeIcon: true,
            content: '<br/>' + this.content(vue, record),
            type: 'red',
            typeAnimated: true,
            buttons: {
                confirm: {
                    text: 'Șterge',
                    btnClass: 'btn-danger btn-sm btn-font-sm',
                    keys: ['enter', 'shift'],
                    action: function(){
                        axios.SetData(record).OnSuccess( () => {
                            vue.$emit('record-deleted', axios.response)
                            fetcher.Refresh()
                        } ).Post()
                    }
                },
                cancel: {
                    text: 'Renunță',
                    btnClass: 'btn-secondary btn-sm',
                    action: function () {},
                },
                
            }
        });
    }

    UnonfirmedDelete(vue, record) {
        this.SetData(record).OnSuccess( () => vue.fetcher.Refresh() ).Post()
    }
}

export default DeleteRecord