import FilterControl from "comptechsoft-vue-foundation/src/~compvuetech/Classes/Filter/FilterControl";

class FilterControlString extends FilterControl {

    constructor(id) {
        super(id)

        this.component = 'fetcher-filter-date'

        this.operators = [
            // {
            //     id: null,
            //     text: 'Selectați un crtiteriu de filtrare'
            // },
            // {
            //     id: 'equal',
            //     text: '='
            // },
        ]

        this.pluginOptions = {
            parentEl: null,
            buttonClasses: 'btn',
            applyClass: 'btn-primary',
            cancelClass: 'btn-secondary',
            opens: 'right',
            drops: 'down',
            ranges: {
                'Azi': [moment(), moment()],
                'Ieri': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
                // 'Last 7 Days': [moment().subtract(6, 'days'), moment()],
                // 'Last 30 Days': [moment().subtract(29, 'days'), moment()],
                'Luna curentă': [moment().startOf('month'), moment().endOf('month')],
                'Luna trecută': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')],
                'Anul curent': [moment().startOf('year'), moment().endOf('year')],
                'Anul trecut': [moment().subtract(1, 'year').startOf('year'), moment().subtract(1, 'year').endOf('year')],
            },
            locale: {
                "format": "DD.MM.YYYY",
                "separator": " - ",
                "applyLabel": "Aplică",
                "cancelLabel": "Renunță",
                "fromLabel": "De la",
                "toLabel": "Până la",
                "customRangeLabel": "Selecteză...",
                "weekLabel": "S",
                "daysOfWeek": [
                    "Du",
                    "Lu",
                    "Ma",
                    "Mi",
                    "Jo",
                    "Vi",
                    "Sâ"
                ],
                "monthNames": [
                    "Ianuarie",
                    "Februarie",
                    "Martie",
                    "Aprilie",
                    "Mai",
                    "Iunie",
                    "Iulie",
                    "August",
                    "Septembrie",
                    "Octombrie",
                    "Noiembrie",
                    "Decembrie"
                ],
                "firstDay": 1
            },
        }
    }
}

export default FilterControlString