import BaseComponent from "../../BaseComponent";
import Collection from "../../../Classes/Collection/Collection";

class Card extends BaseComponent {

    constructor(name) {
        super(name)

        this.component = 'met-card'
        this.caption = 'My Card Caption (' + this.name + ')'
        this.subtitle = ''
        this.icon = ''
        this.closable = true

        this.hasFooter = false

        this.toolbar = new Collection()
    }

    SetIcon(value) {
        this.icon = value
        return this
    }

    SetCaption(value) {
        this.caption = value
        return this
    }

    SetSubtitle(value) {
        this.subtitle = value
        return this
    }

    AddToolbarAction(name, action) {
        this.toolbar.Put(name, action)
        return this
    }

    SetHasFooter(value) {
        this.hasFooter = value
        return this
    }

    get cardCaption() {
        return this.caption
    }

    get toolbarActions() {
        return this.toolbar.All()
    }

}

export default Card