module.exports = {
    props: {
        card: {required: true},
        
    },

    computed: {
        record() {
            return this.card.record
        },

        controls() {
            return this.card.cardControls
        },

        actionButtons() {
            return this.card.cardActionsButton
        },

        axios() {
            return this.card.axios
        }
    },

    watch: {
        'card.visible': {
            handler: function(newVisible, oldVisible) {
                if(newVisible)
                {
                    this.Focus()
                }
            },
            deep: true
        }
    },

    methods: {

        SetFocus(controlName) {
            let i = setInterval(() => {
                if(this.$refs.hasOwnProperty(controlName))
                {
                    clearInterval(i)
                    this.$refs[controlName].$refs.input.focus()
                }
            }, 10)
        },

        OnClickToolbarAction(action) {
            action.OnClick(this)
        },

        OnClickHide() {
            this.card.Hide(this)
        },

        OnClickSubmit() {
            this.axios
                .SetEndpoint(this.card.endpoint)
                .SetData(this.record)
                .SetOnSuccessResponse( () => this.card.onSuccessResponse(this))
                .Post()
        }
    },

    mounted() {
        console.log('Crud Card MOUNTED(' + this.$options.name + ', ' + this.card.name + ')')
    }
}