import Control from "../../Control";

class Selectbox extends Control {

    constructor(name) {
        super(name)

        this.label = 'My Label (' + this.name + ')'
        this.placeholder = 'My placeholder (' + this.name + ')'

        this.fetcher = null

        this.options = []

        this.renderer = record => 'Record #' + record.id

        this.t = null

        /**
         * Numele componentei modal (de exemplu: roles-modal, ...)
         */
        this.modal = null
    }

    SetPlaceholder(value) {
        this.placeholder = value
        return this
    }

    SetLabel(value) {
        this.label = value
        return this
    }

    SetFetcher(value) {
        this.fetcher = value
        return this
    }

    SetRenderer(value) {
        this.renderer = value
        return this
    }

    SetModal(value) {
        this.modal = value
        return this
    }

    get controlOptions() {
        return this.options
    }

    get processing() {
        return this.fetcher.processing
    }

    AddOption(record) {
        let exists = _.find(this.options, item => item.id == record.id)
        if(exists == undefined)
        {
            this.options.push({id: record.id, text: record.text})
        }
        else
        {
            exists.text = record.text
        }
        return this
    }

    Refresh() {
        if(this.fetcher) {
            if(this.t)
            {
                clearTimeout(this.t)
            }
            this.t = setTimeout(() => {
                this.fetcher.OnSuccess( () => {
                    Vue.set(this, 'options', [])
                    this.AddOption({
                        id: null,
                        text: this.placeholder
                    })
                    _.each(this.fetcher.records, record => this.AddOption({
                        id: record.id,
                        text: this.renderer(record),
                    }))
                })
                this.fetcher.Refresh()
            }, 250)
        }
        return this
    }

}

export default Selectbox