import Control from "../../Control";

class Textbox extends Control {

    constructor(name) {
        super(name)

        this.type = 'text'

        this.label = 'My Label (' + this.name + ')'
        this.placeholder = 'My placeholder (' + this.name + ')'
        this.maxlength = null
        this.step = null
        this.decimal = null

        this.vue = null
        this.plugin = null
    }

    SetPlaceholder(value) {
        this.placeholder = value
        return this
    }

    SetLabel(value) {
        this.label = value
        return this
    }

    SetType(value) {
        this.type = value
        return this
    }

    SetStep(value) {
        this.step = value
        return this
    }

    SetMaxlength(value) {
        this.maxlength = value
        return this
    }

    SetDecimal(value) {
        this.decimal = value
        return this
    }

    // https://github.com/RobinHerbots/inputmask
    CreateDecimalInputMaskPlugin(vue) {
        this.vue = vue
        let i = setInterval( () => {
            let jq = $('#input-' + this.id)
            if(jq.length == 1)
            {
                clearInterval(i)
                let options = {
                    alias: 'decimal',
                    groupSeparator: ',',
                    radixPoint: '.',
                    autoGroup: true,
                    digitsOptional: false, 
                    rightAlign : true,
                    clearMaskOnLostFocus: true,
                    autoUnmask: true,
                }
                _.each(this.decimal, (value, key) => {
                    options[key] = value
                })
                this.instance = jq.inputmask('decimal', options); 
                this.instance.on('input', function(e) {
                    vue.$emit('input', e.target.value)
                })
            }
        }, 100)
    }
}

export default Textbox