import BaseComponent from "../../BaseComponent";

class Modal extends BaseComponent {

    constructor(name) {
        super(name)

        this.visible = false

        this.caption = 'My caption (' + this.name + ')'
        this.icon = null

        this.actionButton = {
            icon: 'la la-plus',
            caption: 'Add'
        }

        this.repeat_insert_action = true

        this.vertical_centered = false
        this.large = false

        this.dialog_style = null
        this.content_style = null
        this.header_style = null

        this.movable = true

    }

    SetCaption(value) {
        this.caption = value
        return this
    }

    SetIcon(value) {
        this.icon = value
        return this
    }

    SetRepeatInsertAction(value){
        this.repeat_insert_action = value
        return this
    }

    Centered() {
        this.vertical_centered = true
        return this
    }

    Large() {
        this.large = true
        return this
    }

    SetDialogStyle(value) {
        this.dialog_style = value
        return this
    }

    SetContentStyle(value) {
        this.content_style = value
        return this
    }

    SetHeaderStyle(value) {
        this.header_style = value
        return this
    }

    get modalCaption() {
        if(_.isFunction(this.caption))
        {
            return this.caption(this.action, this.old)
        }
        return this.caption
    }

    ApplyMovable() {
        let id = '#' + this.id + ' .modal-header'
        $(id).on("mousedown", function(e) {

            let $draggable = $(this)
            
            let w = $draggable.width()
            let wb = $("body").width()

            let h = $draggable.height()
            let hb = $("body").height()

            let x = e.pageX - $draggable.offset().left
            let y = e.pageY - $draggable.offset().top

            $("body").on("mousemove.draggable", function(e) {                
                let xx = e.pageX - x, yy = e.pageY - y
                xx = ((xx < 0) ? 0 : xx)
                yy = ((yy < 0) ? 0 : yy)
                if(xx + w + 35 > wb)
                {
                    xx = wb - w - 35
                }
                if(yy + h + 35 > hb)
                {
                    yy = hb - h - 35
                }
                $draggable.closest(".modal-dialog").offset({
                    "left": xx,
                    "top": yy
                });
            });
            $("body").one("mouseup", function() {
                $("body").off("mousemove.draggable");
            });
            $draggable.closest(".modal").one("bs.modal.hide", function() {
                $("body").off("mousemove.draggable");
            });
        })
    }


}

export default Modal